package rate;

import java.io.*;
import java.util.*;
import java.util.regex.*;
import java.net.*;
import org.apache.commons.collections.SequencedHashMap;

public class RateModel {
	protected String url;
	protected String pattern;
	protected Vector currencies;
	protected Vector viewCurrencies;

	public RateModel(String url, String pattern, Vector currencies,
			Vector viewCurrencies) {
		this.url = url;
		this.pattern = pattern;
		this.currencies = currencies;
		this.viewCurrencies = viewCurrencies;
	}

	protected String getContents() throws RateException {
		try {
			URLConnection conn = new URL(url).openConnection();
			BufferedReader br = new BufferedReader(new InputStreamReader(conn
					.getInputStream()));

			StringBuffer sb = new StringBuffer();
			String line;
			while ((line = br.readLine()) != null) {
				sb.append(line + "\n");
			}

			return sb.toString();
		} catch (Exception e) {
			throw new RateException("Failed to connect.");
		}
	}

	public SequencedHashMap getData() throws RateException {
		String contents = getContents();

		SequencedHashMap currencyMap = new SequencedHashMap();
		Pattern p = Pattern.compile(pattern);
		Matcher matcher = p.matcher(contents);
		if (matcher.find()) {
			String group = matcher.group();
			p = Pattern.compile("<td>([0-9]+\\.[0-9][0-9])([0-9]+)<\\/td>");
			matcher = p.matcher(group);
			Iterator it = currencies.iterator();
			while (matcher.find() && it.hasNext()) {
				group = matcher.group(1);
				String currency = (String) it.next();
				if (viewCurrencies.contains(currency)) {
					currencyMap.put(currency, group);
				}
			}
		}

		return currencyMap;
	}
}