package rate;

import org.apache.commons.collections.SequencedHashMap;

public abstract class RateView {
	protected RateController controller;
	protected SequencedHashMap data;
	protected String title;

	public void init(String title, RateController controller) {
		this.title = title;
		this.controller = controller;
		view();
	}

	public void update() {
		showMessage("Loading...");
		try {
			data = controller.getData();
			updateView();
		} catch (RateException e) {
			showMessage(e.getMessage());
		}
	}

	protected abstract void showMessage(String message);

	protected abstract void updateView();

	protected abstract void view();
}