package rate;

import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class RateViewSwing extends RateView {
	protected MyJDialog frame;

	protected void view() {
		frame = new MyJDialog();
		frame.setTitle(title);

		update();

		MouseListener ml = new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				if (e.getModifiers() == InputEvent.BUTTON1_MASK
						&& e.getClickCount() == 2) {
					update();
				}
			}
		};

		frame.addMouseListener(ml);
		frame.setResizable(false);

		Toolkit toolKit = frame.getToolkit();
		Dimension screenSize = toolKit.getScreenSize();
		Rectangle frameSize = frame.getBounds();
		frame.setLocation(screenSize.width - frameSize.width, 0);

		frame.setVisible(true);
	}

	protected void showMessage(String message) {
		Container cont = frame.getContentPane();
		cont.removeAll();

		JPanel panel = new JPanel();

		JLabel label = new JLabel(message);
		label.setHorizontalAlignment(SwingConstants.CENTER);
		label.setVerticalAlignment(SwingConstants.CENTER);

		panel.add(label);
		cont.add(panel);
		frame.pack();

		Dimension d = label.getSize();
		label.paintImmediately(0, 0, d.width, d.height);
	}

	protected void updateView() {
		Container cont = frame.getContentPane();
		cont.removeAll();
		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(data.size(), 2));

		Iterator it = data.sequence().iterator();
		while (it.hasNext()) {
			String currency = (String) it.next();
			String value = (String) data.get(currency);

			JLabel currencyLabel = new JLabel(currency);
			JLabel valueLabel = new JLabel(value);
			valueLabel.setHorizontalAlignment(SwingConstants.CENTER);
			valueLabel.setHorizontalAlignment(SwingConstants.RIGHT);
			panel.add(currencyLabel);
			panel.add(valueLabel);
		}

		cont.add(panel);
		frame.pack();
	}
}

class MyJDialog extends JDialog {
	protected void processWindowEvent(WindowEvent e) {
		super.processWindowEvent(e);
		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			System.exit(0);
		}
	}
}